gtkmm: Gtk::CellAreaContext Class Reference

gtkmm 4.23.2

Public Member Functions | Static Public Member Functions | Related Symbols | List of all members
Gtk::CellAreaContext Class Reference

This stores geometrical information for a series of rows in a CellArea. More...

`#include <gtkmm/cellareacontext.h>`

Inheritance diagram for Gtk::CellAreaContext:
[legend]

## Public Member Functions
| CellAreaContext (CellAreaContext && src) noexcept
CellAreaContext & | operator= (CellAreaContext && src) noexcept
| ~CellAreaContext () noexcept override
GtkCellAreaContext * | gobj ()
| Provides access to the underlying C GObject.
const GtkCellAreaContext * | gobj () const
| Provides access to the underlying C GObject.
GtkCellAreaContext * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
Glib::RefPtr< CellArea > | get_area ()
| Fetches the Gtk::CellArea this context was created by.
Glib::RefPtr< const CellArea > | get_area () const
| Fetches the Gtk::CellArea this context was created by.
void | allocate (int width, int height)
| Allocates a width and/or a height for all rows which are to be rendered with context.
void | reset ()
| Resets any previously cached request and allocation data.
void | get_preferred_width (int & minimum_width, int & natural_width) const
| Gets the accumulative preferred width for all rows which have been requested with this context.
void | get_preferred_height (int & minimum_height, int & natural_height) const
| Gets the accumulative preferred height for all rows which have been requested with this context.
void | get_preferred_height_for_width (int width, int & minimum_height, int & natural_height) const
| Gets the accumulative preferred height for width for all rows which have been requested for the same said width with this context.
void | get_preferred_width_for_height (int height, int & minimum_width, int & natural_width) const
| Gets the accumulative preferred width for height for all rows which have been requested for the same said height with this context.
void | get_allocation (int & width, int & height) const
| Fetches the current allocation size for context.
void | push_preferred_width (int minimum_width, int natural_width)
| Causes the minimum and/or natural width to grow if the new proposed sizes exceed the current minimum and natural width.
void | push_preferred_height (int minimum_height, int natural_height)
| Causes the minimum and/or natural height to grow if the new proposed sizes exceed the current minimum and natural height.
Glib::PropertyProxy_ReadOnly< CellArea * > | property_area () const
| The Gtk::CellArea this context was created by.
Glib::PropertyProxy_ReadOnly< int > | property_minimum_width () const
| The minimum width for the Gtk::CellArea in this context for all Gtk::TreeModel rows that this context was requested for using Gtk::CellArea::get_preferred_width().
Glib::PropertyProxy_ReadOnly< int > | property_natural_width () const
| The natural width for the Gtk::CellArea in this context for all Gtk::TreeModel rows that this context was requested for using Gtk::CellArea::get_preferred_width().
Glib::PropertyProxy_ReadOnly< int > | property_minimum_height () const
| The minimum height for the Gtk::CellArea in this context for all Gtk::TreeModel rows that this context was requested for using Gtk::CellArea::get_preferred_height().
Glib::PropertyProxy_ReadOnly< int > | property_natural_height () const
| The natural height for the Gtk::CellArea in this context for all Gtk::TreeModel rows that this context was requested for using Gtk::CellArea::get_preferred_height().
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data_with_c_callback (const Quark &key, void *data, GDestroyNotify notify)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
PropertyType | get_property (const Glib::ustring &property_name) const
sigc::connection | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void()> &slot)
sigc::connection | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void()> &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src) noexcept
| ~trackable ()
void | add_destroy_notify_callback (notifiable *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src) noexcept
void | remove_destroy_notify_callback (notifiable *data) const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.

## Related Symbols
(Note that these are not member symbols.)
Glib::RefPtr< Gtk::CellAreaContext > | wrap (GtkCellAreaContext * object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Additional Inherited Members
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify
Public Types inherited from sigc::notifiable
typedef internal::func_destroy_notify | func_destroy_notify
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)

## Detailed Description

This stores geometrical information for a series of rows in a CellArea.

CellAreaContext is used by widgets such as TreeView and IconView, but application developers do not usually need to be aware of it.

The CellAreaContext object is created by a given CellArea and is used to store cell sizes and alignments for a series of TreeModel rows that are requested and rendered in the same context.

CellLayout widgets can create any number of contexts in which to request and render groups of data rows. However. it's important that the same context which was used to request sizes for a given TreeModel row also be used for the same row when calling other CellArea APIs such as gtk_cell_area_render() and gtk_cell_area_event().

Deprecated
  4.10: List views use widgets for displaying their contents.

## Constructor & Destructor Documentation

## ◆ CellAreaContext()

Gtk::CellAreaContext::CellAreaContext | ( | CellAreaContext && | src | ) |
| noexcept

## ◆ ~CellAreaContext()

Gtk::CellAreaContext::~CellAreaContext | ( |  | ) |
| overridenoexcept

## Member Function Documentation

## ◆ allocate()

void Gtk::CellAreaContext::allocate | ( | int | width,
|  | int | height )

Allocates a width and/or a height for all rows which are to be rendered with context.

Usually allocation is performed only horizontally or sometimes vertically since a group of rows are usually rendered side by side vertically or horizontally and share either the same width or the same height. Sometimes they are allocated in both horizontal and vertical orientations producing a homogeneous effect of the rows. This is generally the case for Gtk::TreeView when GtkTreeView:fixed-height-mode is enabled.

Deprecated: 4.10: This object will be removed in GTK 5

Parameters

  width | The allocated width for all Gtk::TreeModel rows rendered with context, or -1.
  height | The allocated height for all Gtk::TreeModel rows rendered with context, or -1.

## ◆ get_allocation()

void Gtk::CellAreaContext::get_allocation | ( | int & | width,
|  | int & | height ) const

Fetches the current allocation size for context.

If the context was not allocated in width or height, or if the context was recently reset with reset(), the returned value will be -1.

Deprecated: 4.10: This object will be removed in GTK 5

Parameters

  width | Location to store the allocated width.
  height | Location to store the allocated height.

## ◆ get_area() [1/2]

Glib::RefPtr< CellArea > Gtk::CellAreaContext::get_area | ( |  | ) |

Fetches the Gtk::CellArea this context was created by.

This is generally unneeded by layouting widgets; however, it is important for the context implementation itself to fetch information about the area it is being used for.

For instance at GtkCellAreaContextClass.allocate() time it’s important to know details about any cell spacing that the Gtk::CellArea is configured with in order to compute a proper allocation.

Deprecated: 4.10: This object will be removed in GTK 5

Returns
  The Gtk::CellArea this context was created by.

## ◆ get_area() [2/2]

Glib::RefPtr< const CellArea > Gtk::CellAreaContext::get_area | ( |  | ) | const

Fetches the Gtk::CellArea this context was created by.

This is generally unneeded by layouting widgets; however, it is important for the context implementation itself to fetch information about the area it is being used for.

For instance at GtkCellAreaContextClass.allocate() time it’s important to know details about any cell spacing that the Gtk::CellArea is configured with in order to compute a proper allocation.

Deprecated: 4.10: This object will be removed in GTK 5

Returns
  The Gtk::CellArea this context was created by.

## ◆ get_preferred_height()

void Gtk::CellAreaContext::get_preferred_height | ( | int & | minimum_height,
|  | int & | natural_height ) const

Gets the accumulative preferred height for all rows which have been requested with this context.

After reset() is called and/or before ever requesting the size of a Gtk::CellArea, the returned values are 0.

Deprecated: 4.10: This object will be removed in GTK 5

Parameters

  minimum_height | Location to store the minimum height.
  natural_height | Location to store the natural height.

## ◆ get_preferred_height_for_width()

void Gtk::CellAreaContext::get_preferred_height_for_width | ( | int | width,
|  | int & | minimum_height,
|  | int & | natural_height ) const

Gets the accumulative preferred height for width for all rows which have been requested for the same said width with this context.

After reset() is called and/or before ever requesting the size of a Gtk::CellArea, the returned values are -1.

Deprecated: 4.10: This object will be removed in GTK 5

Parameters

  width | A proposed width for allocation.
  minimum_height | Location to store the minimum height.
  natural_height | Location to store the natural height.

## ◆ get_preferred_width()

void Gtk::CellAreaContext::get_preferred_width | ( | int & | minimum_width,
|  | int & | natural_width ) const

Gets the accumulative preferred width for all rows which have been requested with this context.

After reset() is called and/or before ever requesting the size of a Gtk::CellArea, the returned values are 0.

Deprecated: 4.10: This object will be removed in GTK 5

Parameters

  minimum_width | Location to store the minimum width.
  natural_width | Location to store the natural width.

## ◆ get_preferred_width_for_height()

void Gtk::CellAreaContext::get_preferred_width_for_height | ( | int | height,
|  | int & | minimum_width,
|  | int & | natural_width ) const

Gets the accumulative preferred width for height for all rows which have been requested for the same said height with this context.

After reset() is called and/or before ever requesting the size of a Gtk::CellArea, the returned values are -1.

Deprecated: 4.10: This object will be removed in GTK 5

Parameters

  height | A proposed height for allocation.
  minimum_width | Location to store the minimum width.
  natural_width | Location to store the natural width.

## ◆ get_type()

GType Gtk::CellAreaContext::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GtkCellAreaContext * Gtk::CellAreaContext::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GtkCellAreaContext * Gtk::CellAreaContext::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

GtkCellAreaContext * Gtk::CellAreaContext::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ operator=()

CellAreaContext & Gtk::CellAreaContext::operator= | ( | CellAreaContext && | src | ) |
| noexcept

## ◆ property_area()

Glib::PropertyProxy_ReadOnly< CellArea * > Gtk::CellAreaContext::property_area | ( |  | ) | const

The Gtk::CellArea this context was created by.

Deprecated: 4.10: This object will be removed in GTK 5

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_minimum_height()

Glib::PropertyProxy_ReadOnly< int > Gtk::CellAreaContext::property_minimum_height | ( |  | ) | const

The minimum height for the Gtk::CellArea in this context for all Gtk::TreeModel rows that this context was requested for using Gtk::CellArea::get_preferred_height().

Deprecated: 4.10: This object will be removed in GTK 5

Default value: -1

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_minimum_width()

Glib::PropertyProxy_ReadOnly< int > Gtk::CellAreaContext::property_minimum_width | ( |  | ) | const

The minimum width for the Gtk::CellArea in this context for all Gtk::TreeModel rows that this context was requested for using Gtk::CellArea::get_preferred_width().

Deprecated: 4.10: This object will be removed in GTK 5

Default value: -1

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_natural_height()

Glib::PropertyProxy_ReadOnly< int > Gtk::CellAreaContext::property_natural_height | ( |  | ) | const

The natural height for the Gtk::CellArea in this context for all Gtk::TreeModel rows that this context was requested for using Gtk::CellArea::get_preferred_height().

Deprecated: 4.10: This object will be removed in GTK 5

Default value: -1

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_natural_width()

Glib::PropertyProxy_ReadOnly< int > Gtk::CellAreaContext::property_natural_width | ( |  | ) | const

The natural width for the Gtk::CellArea in this context for all Gtk::TreeModel rows that this context was requested for using Gtk::CellArea::get_preferred_width().

Deprecated: 4.10: This object will be removed in GTK 5

Default value: -1

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ push_preferred_height()

void Gtk::CellAreaContext::push_preferred_height | ( | int | minimum_height,
|  | int | natural_height )

Causes the minimum and/or natural height to grow if the new proposed sizes exceed the current minimum and natural height.

This is used by Gtk::CellAreaContext implementations during the request process over a series of Gtk::TreeModel rows to progressively push the requested height over a series of get_preferred_height() requests.

Deprecated: 4.10: This object will be removed in GTK 5

Parameters

  minimum_height | The proposed new minimum height for context.
  natural_height | The proposed new natural height for context.

## ◆ push_preferred_width()

void Gtk::CellAreaContext::push_preferred_width | ( | int | minimum_width,
|  | int | natural_width )

Causes the minimum and/or natural width to grow if the new proposed sizes exceed the current minimum and natural width.

This is used by Gtk::CellAreaContext implementations during the request process over a series of Gtk::TreeModel rows to progressively push the requested width over a series of get_preferred_width() requests.

Deprecated: 4.10: This object will be removed in GTK 5

Parameters

  minimum_width | The proposed new minimum width for context.
  natural_width | The proposed new natural width for context.

## ◆ reset()

void Gtk::CellAreaContext::reset | ( |  | ) |

Resets any previously cached request and allocation data.

When underlying Gtk::TreeModel data changes its important to reset the context if the content size is allowed to shrink. If the content size is only allowed to grow (this is usually an option for views rendering large data stores as a measure of optimization), then only the row that changed or was inserted needs to be (re)requested with get_preferred_width().

When the new overall size of the context requires that the allocated size changes (or whenever this allocation changes at all), the variable row sizes need to be re-requested for every row.

For instance, if the rows are displayed all with the same width from top to bottom then a change in the allocated width necessitates a recalculation of all the displayed row heights using get_preferred_height_for_width().

Deprecated: 4.10: This object will be removed in GTK 5

## Friends And Related Symbol Documentation

## ◆ wrap()

Glib::RefPtr< Gtk::CellAreaContext > wrap | ( | GtkCellAreaContext * | object,
|  | bool | take_copy = false )
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.